// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

#[cfg(feature = "gtk_v3_12")]
#[cfg_attr(docsrs, doc(cfg(feature = "gtk_v3_12")))]
glib::wrapper! {
    #[doc(alias = "DzlSimplePopover")]
    pub struct SimplePopover(Object<ffi::DzlSimplePopover, ffi::DzlSimplePopoverClass>) @extends gtk::Popover, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_simple_popover_get_type(),
    }
}

#[cfg(not(any(feature = "gtk_v3_12")))]
glib::wrapper! {
    #[doc(alias = "DzlSimplePopover")]
    pub struct SimplePopover(Object<ffi::DzlSimplePopover, ffi::DzlSimplePopoverClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_simple_popover_get_type(),
    }
}

impl SimplePopover {
    pub const NONE: Option<&'static SimplePopover> = None;

    #[doc(alias = "dzl_simple_popover_new")]
    pub fn new() -> SimplePopover {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_simple_popover_new()).unsafe_cast() }
    }
}

impl Default for SimplePopover {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::SimplePopover>> Sealed for T {}
}

pub trait SimplePopoverExt: IsA<SimplePopover> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_simple_popover_get_button_text")]
    #[doc(alias = "get_button_text")]
    fn button_text(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_simple_popover_get_button_text(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_simple_popover_get_message")]
    #[doc(alias = "get_message")]
    fn message(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_simple_popover_get_message(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_simple_popover_get_ready")]
    #[doc(alias = "get_ready")]
    fn is_ready(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_simple_popover_get_ready(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_simple_popover_get_text")]
    #[doc(alias = "get_text")]
    fn text(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_simple_popover_get_text(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_simple_popover_get_title")]
    #[doc(alias = "get_title")]
    fn title(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_simple_popover_get_title(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_simple_popover_set_button_text")]
    fn set_button_text(&self, button_text: &str) {
        unsafe {
            ffi::dzl_simple_popover_set_button_text(
                self.as_ref().to_glib_none().0,
                button_text.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_simple_popover_set_message")]
    fn set_message(&self, message: &str) {
        unsafe {
            ffi::dzl_simple_popover_set_message(
                self.as_ref().to_glib_none().0,
                message.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_simple_popover_set_ready")]
    fn set_ready(&self, ready: bool) {
        unsafe {
            ffi::dzl_simple_popover_set_ready(self.as_ref().to_glib_none().0, ready.into_glib());
        }
    }

    #[doc(alias = "dzl_simple_popover_set_text")]
    fn set_text(&self, text: &str) {
        unsafe {
            ffi::dzl_simple_popover_set_text(self.as_ref().to_glib_none().0, text.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_simple_popover_set_title")]
    fn set_title(&self, title: &str) {
        unsafe {
            ffi::dzl_simple_popover_set_title(
                self.as_ref().to_glib_none().0,
                title.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "activate")]
    fn connect_activate<F: Fn(&Self, &str) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn activate_trampoline<
            P: IsA<SimplePopover>,
            F: Fn(&P, &str) + 'static,
        >(
            this: *mut ffi::DzlSimplePopover,
            text: *mut libc::c_char,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                SimplePopover::from_glib_borrow(this).unsafe_cast_ref(),
                &glib::GString::from_glib_borrow(text),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"activate\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    activate_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "changed")]
    fn connect_changed<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn changed_trampoline<P: IsA<SimplePopover>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlSimplePopover,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SimplePopover::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"changed\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    changed_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "insert-text")]
    fn connect_insert_text<F: Fn(&Self, u32, &str, u32) -> bool + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn insert_text_trampoline<
            P: IsA<SimplePopover>,
            F: Fn(&P, u32, &str, u32) -> bool + 'static,
        >(
            this: *mut ffi::DzlSimplePopover,
            position: libc::c_uint,
            chars: *mut libc::c_char,
            n_chars: libc::c_uint,
            f: glib::ffi::gpointer,
        ) -> glib::ffi::gboolean {
            let f: &F = &*(f as *const F);
            f(
                SimplePopover::from_glib_borrow(this).unsafe_cast_ref(),
                position,
                &glib::GString::from_glib_borrow(chars),
                n_chars,
            )
            .into_glib()
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"insert-text\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    insert_text_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "button-text")]
    fn connect_button_text_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_button_text_trampoline<
            P: IsA<SimplePopover>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSimplePopover,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SimplePopover::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::button-text\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_button_text_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "message")]
    fn connect_message_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_message_trampoline<
            P: IsA<SimplePopover>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlSimplePopover,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SimplePopover::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::message\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_message_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "ready")]
    fn connect_ready_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_ready_trampoline<P: IsA<SimplePopover>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlSimplePopover,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SimplePopover::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::ready\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_ready_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "text")]
    fn connect_text_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_text_trampoline<P: IsA<SimplePopover>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlSimplePopover,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SimplePopover::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::text\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_text_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "title")]
    fn connect_title_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_title_trampoline<P: IsA<SimplePopover>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlSimplePopover,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(SimplePopover::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::title\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_title_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<SimplePopover>> SimplePopoverExt for O {}

impl fmt::Display for SimplePopover {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("SimplePopover")
    }
}
